package	jp.co.sds_corp.util.jmx.rmi.client;

import java.io.File;
import java.net.URL;

import javax.management.ObjectName;
import javax.naming.InitialContext;

import jp.co.sds_corp.util.jmx.rmi.JMXAdaptor;

public class Deployer
{
	public static void main(String[] args) throws Exception {
		for(int count=0;count<args.length;count++) {            
			if(!args[count].equalsIgnoreCase("-undeploy")) { 
				System.out.println("Deploying " + args[count]);
							new Deployer().deploy(args[count]);
				System.out.println(args[count] + " has been deployed successfully");
			} else {
				System.out.println("Undeploying " + args[++count]);
							new Deployer().undeploy(args[count]);
				System.out.println(args[count] + " has been successfully undeployed");
			}
		}
	}

	public void deploy(String url) throws Exception {
		ObjectName containerFactory = createFactoryName();
		URL deploymentUrl =createUrl(url);
		JMXAdaptor server = lookupAdaptor();

		server.invoke(containerFactory, "deploy", 
					new Object[] { deploymentUrl.toString() }, 
					new String[] { "java.lang.String" });
	}

	public void undeploy(String url) throws Exception {
		ObjectName containerFactory = createFactoryName();
		URL deploymentUrl=createUrl(url);
		JMXAdaptor server = lookupAdaptor();

		server.invoke(containerFactory, "undeploy", 
					new Object[] { deploymentUrl.toString() }, 
					new String[] { "java.lang.String" });
	}

	protected ObjectName createFactoryName() throws javax.management.MalformedObjectNameException {
		return new ObjectName("J2EE:service=J2eeDeployer");
	}

	protected URL createUrl(String url) throws java.net.MalformedURLException {
		if (new File(url).exists()) {
			return new File(url).toURI().toURL();
		} else {
			return new URL(url);
		}
	}

	protected JMXAdaptor lookupAdaptor() throws javax.naming.NamingException {
		return (JMXAdaptor)new InitialContext().lookup("jmx");
	}
}

